routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\LevelController;
use App\Http\Controllers\PersonController;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
})->name('home');

Route::resource('persons', PersonController::class);

Route::resource('levels', LevelController::class);

app/Models/Person.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Person extends Model
{
    use HasFactory;
    /**
     * 
     */
    protected $table = 'persons';

    /**
     * 
     */
    protected $fillable = [
        'name', 'phone', 'email', 'referral_name', 'level_id'
    ];

    /**
     * Get the phone associated with the user.
     */
    public function level()
    {
        return $this->belongsTo(Level::class);
    }    
}

app/Http/Controllers/PersonController.php
<?php

namespace App\Http\Controllers;

use App\Models\Person;
use Illuminate\Http\Request;
use App\Http\Requests\StorePersonRequest;
use App\Models\Level;
use App\Repositories\PersonRepository;

class PersonController extends Controller
{
    /**
     * 
     */
    private $repository;

    public function __construct(PersonRepository $repository)
    {
        $this->repository = $repository;
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        
        $allData = Person::paginate(5);
        return view('person.index', compact('allData'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $levels = Level::latest()->get(['id', 'level_name']);
        return view('person.create', compact('levels'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(StorePersonRequest $request)
    {
        $this->repository->create([
            'name'  => ucwords($request->name),
            'phone' => $request->phone,
            'email' => strtolower($request->email),
            'referral_name' => ucwords($request->referral_name),
            'level_id' => $request->level,
        ]);

        return redirect()
            ->route('persons.index')
            ->with('success', 'Registro exitoso.');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Person  $person
     * @return \Illuminate\Http\Response
     */
    public function show(Person $person)
    {
        
        return view('person.show', compact('person'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Person  $person
     * @return \Illuminate\Http\Response
     */
    public function edit(Person $person)
    {
        $levels = Level::get(['id', 'level_name']);
        return \view('person.edit', compact('person', 'levels'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Person  $person
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Person $person)
    {
        $this->repository->update($person, [
            'name'  => ucwords($request->name),
            'phone' => $request->phone,
            'email' => strtolower($request->email),
            'referral_name' => ucwords($request->referral_name),
            'level_id'  => $request->level
        ]);

        return redirect()
            ->route('persons.index')
            ->with('success', 'El registro de ' . $person->name . ' ha sido actualizado con exito.');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Person  $person
     * @return \Illuminate\Http\Response
     */
    public function destroy(Person $person)
    {
        $person->delete();

        return redirect()
            ->route('persons.index')
            ->with('success', 'Registro de ' . $person->name . ' ha sido eliminado con exito.' );
    }
}

resources/views/person/create.blade.php
<!-- resources/views/person/create.blade.php -->
@extends('layouts.app')

@section('content')
<div class="container">
  <h1 class="border-bottom font-weight-bold mt-4 mx-auto pb-2 text-black-50 text-center text-uppercase w-75">Nuevo
    Registro</h1>
  <div class="justify-content-center row">
    <div class="col-12">
    </div>
    <div class="col-12 col-md-6">
      <a class="btn btn-outline-secondary btn-sm mt-3 px-4" href="{{ route('persons.index') }}">Regresar</a>
      <div class="p-3 border mt-3 rounded">
        <form class="row" action="{{ route('persons.store') }}" method="post">
          @csrf
          <div class="mb-3 col-md-12">
            <label for="name" class="form-label">Nombre Completo</label>
            <input type="text" class="form-control text-capitalize" id="name" name="name" placeholder="Jhon Doe..." value="{{ old('name') }}" />
			@error('name')
				<div class="alert py-1 alert-danger mt-1">{{ $message }}</div>
			@enderror
          </div>
          <div class="mb-3 col-md-6">
            <label for="phone" class="form-label">Número de Teléfono</label>
            <input type="tel" class="form-control" id="phone" name="phone" placeholder="+12555..." value="{{ old('phone') }}" />
			@error('phone')
				<div class="alert py-1 alert-danger mt-1">{{ $message }}</div>
			@enderror			
          </div>
          <div class="mb-3 col-md-6">
            <label for="email" class="form-label">Correo Electrónico</label>
            <input type="email" class="form-control" id="email" name="email" placeholder="example@example.com" value="{{ old('email') }}" />
			@error('email')
				<div class="alert py-1 alert-danger mt-1">{{ $message }}</div>
			@enderror			
          </div>
          <div class="mb-3 col-md-6">
            <label for="referral_name" class="form-label">Nombre de la persona que lo refirio</label>
            <input type="text" class="form-control text-capitalize" id="referral_name" name="referral_name"
              placeholder="Jhon Doe.." value="{{ old('referral_name') }}" />
			  @error('referral_name')
			  <div class="alert py-1 alert-danger mt-1">{{ $message }}</div>
		  @enderror			  
          </div>
          <div class="mb-3 col-md-6">
            <label for="level" class="form-label">Nivel</label>
            <select class="form-select" name="level" id="level">
              <option selected>Open this select menu</option>
              @forelse ($levels as $item)
              <option value="{{ $item->id }}">{{ $item->level_name }}</option>
              @empty
                  
              @endforelse
            </select>
			@error('level')
				<div class="alert py-1 alert-danger mt-1">{{ $message }}</div>
			@enderror
          </div>
          <div class="mb-3 col-md-12 text-center mt-3">
            <button class="btn btn-outline-success btn-sm px-3 text-capitalize" type="submit">Añadir Registro</button>
          </div>
        </form>
      </div>
    </div>
  </div>
</div>
@endsection

resources/views/person/edit.blade.php
<!-- resources/views/person/create.blade.php -->
@extends('layouts.app')

@section('content')
<div class="container">
  <h1 class="border-bottom font-weight-bold mt-4 mx-auto pb-2 text-black-50 text-center text-uppercase w-75">Actualizar Datos</h1>
  <div class="justify-content-center row">
    <div class="col-12">
    </div>
    <div class="col-12 col-md-6">
      <a class="btn btn-outline-secondary btn-sm mt-3 px-4" href="{{ route('persons.index') }}">Regresar</a>
      <div class="p-3 border mt-3 rounded">
        <form class="row" action="{{ route('persons.update', $person) }}" method="post">
          @csrf
          @method('PATCH')
          <div class="mb-3 col-md-12">
            <label for="name" class="form-label">Nombre Completo</label>
            <input type="text" class="form-control text-capitalize" id="name" name="name" placeholder="Jhon Doe..." value="{{ old('name', $person->name) }}" />
			@error('name')
				<div class="alert py-1 alert-danger mt-1">{{ $message }}</div>
			@enderror
          </div>
          <div class="mb-3 col-md-6">
            <label for="phone" class="form-label">Número de Teléfono</label>
            <input type="tel" class="form-control" id="phone" name="phone" placeholder="+12555..." value="{{ old('phone', $person->phone) }}" />
			@error('phone')
				<div class="alert py-1 alert-danger mt-1">{{ $message }}</div>
			@enderror			
          </div>
          <div class="mb-3 col-md-6">
            <label for="email" class="form-label">Correo Electrónico</label>
            <input type="email" class="form-control" id="email" name="email" placeholder="example@example.com" value="{{ old('email', $person->email) }}" />
			@error('email')
				<div class="alert py-1 alert-danger mt-1">{{ $message }}</div>
			@enderror			
          </div>
          <div class="mb-3 col-md-6">
            <label for="referral_name" class="form-label">Nombre de la persona que lo refirio</label>
            <input type="text" class="form-control text-capitalize" id="referral_name" name="referral_name"
              placeholder="Jhon Doe.." value="{{ old('referral_name', $person->referral_name) }}" />
			  @error('referral_name')
			  <div class="alert py-1 alert-danger mt-1">{{ $message }}</div>
		  @enderror			  
          </div>
          <div class="mb-3 col-md-6">
            <label for="level" class="form-label">Nivel</label>
            <select class="form-select" name="level" id="level">
              @forelse ($levels as $item)
              <option value="{{ $item->id }}" @if ($item->id === $person->level_id ) selected @endif>{{ $item->level_name }}</option>
              @empty
              <option selected>Open this select menu</option>
              @endforelse
            </select>
			@error('level')
				<div class="alert py-1 alert-danger mt-1">{{ $message }}</div>
			@enderror
          </div>
          <div class="mb-3 col-md-12 text-center mt-3">
            <button class="btn btn-outline-success btn-sm px-3 text-capitalize" type="submit">Actualizar Registro</button>
          </div>
        </form>
      </div>
    </div>
  </div>
</div>
@endsection

resources/views/person/index.blade.php
<!-- resources/views/person/index.blade.php -->

@extends('layouts.app')

@section('content')
<div class="container">
	<h1 class="text-center font-weight-bold text-uppercase mt-3">Crud con laravel</h1>

	<div class="row">
		<div class="col-12 text-end border-bottom pb-3">
			<a class="btn btn-outline-info btn-sm" href="{{ route('persons.create') }}">Nuevo</a>
		</div>
		<div class="col-12">
			<div class="table-responsive mt-3">
				<!-- will be used to show any messages -->
				@if ( session('success') )
					<div class="alert alert-info py-2">{{ Session::get('success') }}</div>
				@endif				
				<table class="table table-hover">
					<thead>
						<tr>
							<th>#</th>
							<th>Nombre</th>
							<th>Teléfono</th>
							<th>Correo Electrónico</th>
							<th>Nivel</th>
							<th>Acción</th>
						</tr>
					</thead>
					<tbody>
						@forelse ($allData as $data)
						<tr>
							<th><a class="btn btn-sm btn-outline-dark px-3 py-0" href="{{ route('persons.show', $data) }}">{{ $loop->iteration }}</a></th>
							<td>{{ $data->name }}</td>
							<td>{{ $data->phone }}</td>
							<td>{{ $data->email }}</td>
							<td>{{ $data->level->level_name}}</td>
							<td>
								<a class="btn btn-success btn-sm" href="{{ route('persons.edit', $data) }}"><span class="sr-only">Editar</span></a>
								<form class="d-inline" action="{{ route('persons.destroy', $data) }}" method="post">
									@csrf
									@method('DELETE')
									<input class="btn btn-outline-danger btn-sm" type="submit" name="" value="Eliminar">
								</form>
							</td>
						</tr>
						@empty
						<tr>
							<th colspan="6" class="text-center">No hay datos disponibles.</th>
						</tr>
						@endforelse
					</tbody>

				</table>
				<div class="border-bottom mt-4 py-2 text-end">
					{{ $allData->links() }}
				</div>
			</div>
		</div>
	</div>

</div>
@endsection

resources/views/person/show.blade.php
<!-- resources/views/person/index.blade.php -->

@extends('layouts.app')

@section('content')
<div class="container">
	<h1 class="text-center font-weight-bold text-uppercase mt-3">{{ $person->name }}</h1>

	<div class="row justify-content-center flex-column align-items-center">
        <div class="col-md-6">
            <p class="text-center text-uppercase">Datos Personales</p>
            <ul class="list-group mt-3">
                <li class="list-group-item text-center"><strong class="d-block mb-2">Numero de teléfono</strong> {{ $person->phone }}</li>
                <li class="list-group-item text-center"><strong class="d-block mb-2">Correo electrónico</strong> {{ $person->email }}</li>
                <li class="list-group-item text-center"><strong class="d-block mb-2">Quien lo refirio</strong> {{ $person->referral_name }}</li>
                <li class="list-group-item text-center"><strong class="d-block mb-2">Nivel actual</strong> {{ $person->level->level_name }}</li>
                <li class="list-group-item text-end">
                    <a class="btn btn-outline-secondary btn-sm mt-3 px-4" href="{{ route('persons.index') }}">Regresar</a>
                </li>
            </ul>
        </div>
        
	</div>

</div>
@endsection